@echo off
rem ======================================================================
::
::  Geburtstags-Checker
::
::  Eine Textdatei mit Geburtstagsdaten wird geparst und die nchsten
::  Geburtstage ausgegeben
::
::  Das Skript erfordert:
::  showdate
::
rem ----------------------------------------------------------------------
::  2007-01-11  AHA  erste Zeilen...
::  2007-08-15  AHA  aktuelles Datum - Monat + Tag einstellig abfragen
::  2007-09-06  AHA  fhrende Null bei CurD
::  2008-12-15  AHA  nextM im Dezember korrigiert
::  http://www.axel-hahn.de/axel/page_compi/bat_bginfo.htm
rem ======================================================================

rem ----------------------------------------------------------------------
::  CONFIG
rem ----------------------------------------------------------------------

	set cfgfile=%~dp0\birthday.txt
	set exeShowdate=%~dp0\showdate.exe
	
rem ----------------------------------------------------------------------
::  MAIN
rem ----------------------------------------------------------------------

	:: --- get current date
	for /F "tokens=1-3 delims=-" %%a in ('%exeShowdate% /f:"yyyy-m-d"') do ( 
		set curY=%%a
		set curM=%%b
		set curD=%%c
	)

	set nextY=%curY%
	set /a nextM=%curM%+1
	if %nextM%==13 ( set /a nextY=%nextY%+1 && set nextM=01 )

	if %curM% LEQ 9 ( set curM=0%curM%)
	if %curD% LEQ 9 ( set curD=0%curD%)
	if %nextM% LEQ 9 ( set nextM=0%nextM%)

	for /F "tokens=1,2 delims=:" %%a in ('findstr /c:"-%curM%-" %cfgfile%') do call :show1 "%%a" "%%b"
	for /F "tokens=1,2 delims=:" %%a in ('findstr /c:"-%nextM%-" %cfgfile%') do call :show1 "%%a" "%%b"
	goto end
	
	:show1
	set birthday=%~1
	set sName=%~2
	for /F "tokens=1-3 delims=-" %%a in ('echo %birthday%') do (
		set bdY=%%a
		set bdM=%%b
		set bdD=%%c
	)
	set /a year=%curY%-%bdY%

	set out=%bdD%.%bdM%: %sName%
	if %year% NEQ %curY% set out=%out% (%year% .. %bdY%)
	echo %birthday% | findstr /c:"-%curM%-%curD%" >nul && echo %out% ^<^<^< TODAY !!!
	echo %birthday% | findstr /c:"-%curM%-"  >nul && if %curD% LSS %bdD% echo %out%
	echo %birthday% | findstr /c:"-%nextM%-" >nul && echo %out%
	
	goto end2
	
	
	:end
	rem ping -n 5 localhost >nul
	
	:end2
	
	
rem ======================================================================
::  EOF
rem ====================================================================== 
