@echo off
rem ======================================================================
::
::  BGINFO-PLUGIN
::  CHECK A LIST OF SERVICES
::
::  laufende Dienste ermitteln .. Skript loopt den Test in einem offen 
::  stehendem Fenster. Der Status wird als Title angezeigt - das Ganze
::  kann so auch minimiert laufen
::
::  Tests: NT4, XP
::
rem ----------------------------------------------------------------------
::  2005-11-03  AHA  Services werden rechnerspezifisch aus einer Datei
::                   geholt; nur 1 x net send pro Loop ber alle Services;
::                   Filter - nur Anzeige der Fehler (verhindert Scrollen)
::  2005-01-12  AHA  erste Zeilen...
::  http://www.axel-hahn.de/axel/page_compi/bat_bginfo.htm
rem ======================================================================

rem ----------------------------------------------------------------------
::  CONFIG
rem ----------------------------------------------------------------------
	set cfgfile=%computername%_services.txt
	set cfgfile2=%computername%_settings.bat
	set cfgfile3=_default_settings.bat

	set cColError=color cf
	set cColOK=color 2f
	
	set LINE=-------------------------------------------------------------------------------
	set sNetstatFILE1="%temp%\services_%computername%_netstat.tmp"
	set sTMPFILE1="%temp%\services_%computername%_1.tmp"
	set sTMPFILE2="%temp%\services_%computername%_2.tmp"

	set errorsOnly=1

rem ----------------------------------------------------------------------
::  MAIN
rem ----------------------------------------------------------------------
	if -%1-==-- goto runnormal
	set sService=%1
	goto checkservice

	rem ----------------------------------------------------------------------
	:runnormal
	rem ----------------------------------------------------------------------
	:: if exist %cfgfile3% call %cfgfile3%
	if NOT exist %cfgfile2% copy %cfgfile3% %cfgfile2% >nul 2>nul
	if exist %cfgfile2% call %cfgfile2%

	if exist %cfgfile% goto loop
	echo.
	echo OOPS: no config exists for computer %computername%
	echo       I will create the list with all running services now.
	echo       Delete the unnecessary lines in notepad and save the file.
	echo.
	rem pause
	net start | find "   " >> %cfgfile%
	notepad %cfgfile%

	rem ----------------------------------------------------------------------
	:loop
	rem ----------------------------------------------------------------------    

	net start >%sNetstatFILE1%
	for /F "tokens=*" %%a in ('type %cfgfile%') do call :checkservice "%%a"
	del %sTMPFILE1% "%sNetstatFILE1%"
	goto ende


	rem ----------------------------------------------------------------------
	:checkservice
	rem ----------------------------------------------------------------------
	findstr /c:%1 %sNetstatFILE1% >nul
	if %ERRORLEVEL%==0 goto OK
	goto ende

	:ERROR
	rem echo %time% miss service %sService%
	echo missing service %1

	:OK
	if %errorsOnly%==0 echo %time% - OK    - %1
	goto ende


rem ----------------------------------------------------------------------
::  ENDE
rem ----------------------------------------------------------------------

	:ende


rem ======================================================================
::  EOF
rem ======================================================================
